float4x4 m: register(c0);	//viewworld transform matrix
float4x4 mll: register(c4);	//loca light rotation matrix
float4 ld: register(c8);	//light direction
float4 lc: register(c12);	//light color

struct _IN
{
  float4 pos   : POSITION;
  float4 norm  : NORMAL;
  float2 uv    : TEXCOORD;
};

struct _OUT
{
  float4 pos  : POSITION;
  float4 col  : COLOR;
  float2 uv   : TEXCOORD;
};

_OUT main(_IN In)
{
  _OUT Out;
  float4 normal;
  float intensity;

  normal = mul(mll, In.norm);		//local normal = local light rotation matrix * normal
  intensity = dot(normal, ld);		//intensity = cos(angle between normal and light direction)
  intensity = max(intensity,0);		//if intensitiy < 0 then intensity = 0
  Out.col = lc * intensity;		//color = light color * intensity of reflected light
  Out.pos = mul(m, In.pos);		//local position = viewworld transform matrix * position
  Out.uv  = In.uv;			//mapping point is unchanged
  return Out;
}
